<a id="mypy-boto3-mediaconnect"></a>

# mypy-boto3-mediaconnect

[![PyPI - mypy-boto3-mediaconnect](https://img.shields.io/pypi/v/mypy-boto3-mediaconnect.svg?color=blue)](https://pypi.org/project/mypy-boto3-mediaconnect)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-mediaconnect.svg?color=blue)](https://pypi.org/project/mypy-boto3-mediaconnect)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_mediaconnect/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-mediaconnect?color=blue)](https://pypistats.org/packages/mypy-boto3-mediaconnect)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.MediaConnect 1.26.113](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/mediaconnect.html#MediaConnect)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-mediaconnect docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_mediaconnect/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-mediaconnect](#mypy-boto3-mediaconnect)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `MediaConnect`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `MediaConnect` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[mediaconnect]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[mediaconnect]'


# standalone installation
python -m pip install mypy-boto3-mediaconnect
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-mediaconnect
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[mediaconnect]` in your environment:

```bash
python -m pip install 'boto3-stubs[mediaconnect]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[mediaconnect]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[mediaconnect]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[mediaconnect]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[mediaconnect]` with services you use in your
  environment:

```bash
python -m pip install 'boto3-stubs[mediaconnect]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[mediaconnect]` in your environment:

```bash
python -m pip install 'boto3-stubs[mediaconnect]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[mediaconnect]` in your environment:

```bash
python -m pip install 'boto3-stubs[mediaconnect]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`MediaConnectClient` provides annotations for `boto3.client("mediaconnect")`.

```python
from boto3.session import Session

from mypy_boto3_mediaconnect import MediaConnectClient

client: MediaConnectClient = Session().client("mediaconnect")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_mediaconnect.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_mediaconnect import MediaConnectClient
from mypy_boto3_mediaconnect.paginator import (
    ListBridgesPaginator,
    ListEntitlementsPaginator,
    ListFlowsPaginator,
    ListGatewayInstancesPaginator,
    ListGatewaysPaginator,
    ListOfferingsPaginator,
    ListReservationsPaginator,
)

client: MediaConnectClient = Session().client("mediaconnect")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_bridges_paginator: ListBridgesPaginator = client.get_paginator("list_bridges")
list_entitlements_paginator: ListEntitlementsPaginator = client.get_paginator("list_entitlements")
list_flows_paginator: ListFlowsPaginator = client.get_paginator("list_flows")
list_gateway_instances_paginator: ListGatewayInstancesPaginator = client.get_paginator(
    "list_gateway_instances"
)
list_gateways_paginator: ListGatewaysPaginator = client.get_paginator("list_gateways")
list_offerings_paginator: ListOfferingsPaginator = client.get_paginator("list_offerings")
list_reservations_paginator: ListReservationsPaginator = client.get_paginator("list_reservations")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_mediaconnect.waiter` module contains type annotations for all
waiters.

```python
from boto3.session import Session

from mypy_boto3_mediaconnect import MediaConnectClient
from mypy_boto3_mediaconnect.waiter import FlowActiveWaiter, FlowDeletedWaiter, FlowStandbyWaiter

client: MediaConnectClient = Session().client("mediaconnect")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
flow_active_waiter: FlowActiveWaiter = client.get_waiter("flow_active")
flow_deleted_waiter: FlowDeletedWaiter = client.get_waiter("flow_deleted")
flow_standby_waiter: FlowStandbyWaiter = client.get_waiter("flow_standby")
```

<a id="literals"></a>

### Literals

`mypy_boto3_mediaconnect.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_mediaconnect.literals import (
    AlgorithmType,
    BridgePlacementType,
    BridgeStateType,
    ColorimetryType,
    ConnectionStatusType,
    DesiredStateType,
    DurationUnitsType,
    EncoderProfileType,
    EncodingNameType,
    EntitlementStatusType,
    FailoverModeType,
    FlowActiveWaiterName,
    FlowDeletedWaiterName,
    FlowStandbyWaiterName,
    GatewayStateType,
    InstanceStateType,
    KeyTypeType,
    ListBridgesPaginatorName,
    ListEntitlementsPaginatorName,
    ListFlowsPaginatorName,
    ListGatewayInstancesPaginatorName,
    ListGatewaysPaginatorName,
    ListOfferingsPaginatorName,
    ListReservationsPaginatorName,
    MaintenanceDayType,
    MediaStreamTypeType,
    NetworkInterfaceTypeType,
    PriceUnitsType,
    ProtocolType,
    RangeType,
    ReservationStateType,
    ResourceTypeType,
    ScanModeType,
    SourceTypeType,
    StateType,
    StatusType,
    TcsType,
    MediaConnectServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)


def check_value(value: AlgorithmType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_mediaconnect.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_mediaconnect.type_defs import (
    VpcInterfaceAttachmentTypeDef,
    AddBridgeNetworkOutputRequestTypeDef,
    AddBridgeNetworkSourceRequestTypeDef,
    ResponseMetadataTypeDef,
    AddEgressGatewayBridgeRequestTypeDef,
    VpcInterfaceRequestTypeDef,
    VpcInterfaceTypeDef,
    AddIngressGatewayBridgeRequestTypeDef,
    AddMaintenanceTypeDef,
    EncryptionTypeDef,
    BridgeFlowOutputTypeDef,
    BridgeNetworkOutputTypeDef,
    BridgeNetworkSourceTypeDef,
    EgressGatewayBridgeTypeDef,
    IngressGatewayBridgeTypeDef,
    MessageDetailTypeDef,
    GatewayNetworkTypeDef,
    DeleteBridgeRequestRequestTypeDef,
    DeleteFlowRequestRequestTypeDef,
    DeleteGatewayRequestRequestTypeDef,
    DeregisterGatewayInstanceRequestRequestTypeDef,
    DescribeBridgeRequestRequestTypeDef,
    WaiterConfigTypeDef,
    DescribeFlowRequestRequestTypeDef,
    MessagesTypeDef,
    DescribeGatewayInstanceRequestRequestTypeDef,
    DescribeGatewayRequestRequestTypeDef,
    DescribeOfferingRequestRequestTypeDef,
    DescribeReservationRequestRequestTypeDef,
    InterfaceRequestTypeDef,
    InterfaceTypeDef,
    EncodingParametersRequestTypeDef,
    EncodingParametersTypeDef,
    SourcePriorityTypeDef,
    MaintenanceTypeDef,
    FmtpRequestTypeDef,
    FmtpTypeDef,
    PaginatorConfigTypeDef,
    ListBridgesRequestRequestTypeDef,
    ListedBridgeTypeDef,
    ListEntitlementsRequestRequestTypeDef,
    ListedEntitlementTypeDef,
    ListFlowsRequestRequestTypeDef,
    ListGatewayInstancesRequestRequestTypeDef,
    ListedGatewayInstanceTypeDef,
    ListGatewaysRequestRequestTypeDef,
    ListedGatewayTypeDef,
    ListOfferingsRequestRequestTypeDef,
    ListReservationsRequestRequestTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ResourceSpecificationTypeDef,
    TransportTypeDef,
    PurchaseOfferingRequestRequestTypeDef,
    RemoveBridgeOutputRequestRequestTypeDef,
    RemoveBridgeSourceRequestRequestTypeDef,
    RemoveFlowMediaStreamRequestRequestTypeDef,
    RemoveFlowOutputRequestRequestTypeDef,
    RemoveFlowSourceRequestRequestTypeDef,
    RemoveFlowVpcInterfaceRequestRequestTypeDef,
    RevokeFlowEntitlementRequestRequestTypeDef,
    StartFlowRequestRequestTypeDef,
    StopFlowRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateBridgeNetworkOutputRequestTypeDef,
    UpdateBridgeNetworkSourceRequestTypeDef,
    UpdateEgressGatewayBridgeRequestTypeDef,
    UpdateIngressGatewayBridgeRequestTypeDef,
    UpdateBridgeStateRequestRequestTypeDef,
    UpdateEncryptionTypeDef,
    UpdateMaintenanceTypeDef,
    UpdateGatewayInstanceRequestRequestTypeDef,
    AddBridgeFlowSourceRequestTypeDef,
    BridgeFlowSourceTypeDef,
    GatewayBridgeSourceTypeDef,
    SetGatewayBridgeSourceRequestTypeDef,
    UpdateBridgeFlowSourceRequestTypeDef,
    UpdateGatewayBridgeSourceRequestTypeDef,
    AddBridgeOutputRequestTypeDef,
    DeleteBridgeResponseTypeDef,
    DeleteFlowResponseTypeDef,
    DeleteGatewayResponseTypeDef,
    DeregisterGatewayInstanceResponseTypeDef,
    EmptyResponseMetadataTypeDef,
    ListTagsForResourceResponseTypeDef,
    RemoveBridgeOutputResponseTypeDef,
    RemoveBridgeSourceResponseTypeDef,
    RemoveFlowMediaStreamResponseTypeDef,
    RemoveFlowOutputResponseTypeDef,
    RemoveFlowSourceResponseTypeDef,
    RemoveFlowVpcInterfaceResponseTypeDef,
    RevokeFlowEntitlementResponseTypeDef,
    StartFlowResponseTypeDef,
    StopFlowResponseTypeDef,
    UpdateBridgeStateResponseTypeDef,
    UpdateGatewayInstanceResponseTypeDef,
    AddFlowVpcInterfacesRequestRequestTypeDef,
    AddFlowVpcInterfacesResponseTypeDef,
    EntitlementTypeDef,
    GrantEntitlementRequestTypeDef,
    BridgeOutputTypeDef,
    GatewayInstanceTypeDef,
    CreateGatewayRequestRequestTypeDef,
    GatewayTypeDef,
    DescribeFlowRequestFlowActiveWaitTypeDef,
    DescribeFlowRequestFlowDeletedWaitTypeDef,
    DescribeFlowRequestFlowStandbyWaitTypeDef,
    DestinationConfigurationRequestTypeDef,
    InputConfigurationRequestTypeDef,
    DestinationConfigurationTypeDef,
    InputConfigurationTypeDef,
    FailoverConfigTypeDef,
    UpdateFailoverConfigTypeDef,
    ListedFlowTypeDef,
    MediaStreamAttributesRequestTypeDef,
    MediaStreamAttributesTypeDef,
    ListBridgesRequestListBridgesPaginateTypeDef,
    ListEntitlementsRequestListEntitlementsPaginateTypeDef,
    ListFlowsRequestListFlowsPaginateTypeDef,
    ListGatewayInstancesRequestListGatewayInstancesPaginateTypeDef,
    ListGatewaysRequestListGatewaysPaginateTypeDef,
    ListOfferingsRequestListOfferingsPaginateTypeDef,
    ListReservationsRequestListReservationsPaginateTypeDef,
    ListBridgesResponseTypeDef,
    ListEntitlementsResponseTypeDef,
    ListGatewayInstancesResponseTypeDef,
    ListGatewaysResponseTypeDef,
    OfferingTypeDef,
    ReservationTypeDef,
    UpdateBridgeOutputRequestRequestTypeDef,
    UpdateFlowEntitlementRequestRequestTypeDef,
    AddBridgeSourceRequestTypeDef,
    BridgeSourceTypeDef,
    UpdateBridgeSourceRequestRequestTypeDef,
    AddBridgeOutputsRequestRequestTypeDef,
    GrantFlowEntitlementsResponseTypeDef,
    UpdateFlowEntitlementResponseTypeDef,
    GrantFlowEntitlementsRequestRequestTypeDef,
    AddBridgeOutputsResponseTypeDef,
    UpdateBridgeOutputResponseTypeDef,
    DescribeGatewayInstanceResponseTypeDef,
    CreateGatewayResponseTypeDef,
    DescribeGatewayResponseTypeDef,
    MediaStreamOutputConfigurationRequestTypeDef,
    MediaStreamSourceConfigurationRequestTypeDef,
    MediaStreamOutputConfigurationTypeDef,
    MediaStreamSourceConfigurationTypeDef,
    UpdateBridgeRequestRequestTypeDef,
    UpdateFlowRequestRequestTypeDef,
    ListFlowsResponseTypeDef,
    AddMediaStreamRequestTypeDef,
    UpdateFlowMediaStreamRequestRequestTypeDef,
    MediaStreamTypeDef,
    DescribeOfferingResponseTypeDef,
    ListOfferingsResponseTypeDef,
    DescribeReservationResponseTypeDef,
    ListReservationsResponseTypeDef,
    PurchaseOfferingResponseTypeDef,
    AddBridgeSourcesRequestRequestTypeDef,
    CreateBridgeRequestRequestTypeDef,
    AddBridgeSourcesResponseTypeDef,
    BridgeTypeDef,
    UpdateBridgeSourceResponseTypeDef,
    AddOutputRequestTypeDef,
    UpdateFlowOutputRequestRequestTypeDef,
    SetSourceRequestTypeDef,
    UpdateFlowSourceRequestRequestTypeDef,
    OutputTypeDef,
    SourceTypeDef,
    AddFlowMediaStreamsRequestRequestTypeDef,
    AddFlowMediaStreamsResponseTypeDef,
    UpdateFlowMediaStreamResponseTypeDef,
    CreateBridgeResponseTypeDef,
    DescribeBridgeResponseTypeDef,
    UpdateBridgeResponseTypeDef,
    AddFlowOutputsRequestRequestTypeDef,
    AddFlowSourcesRequestRequestTypeDef,
    CreateFlowRequestRequestTypeDef,
    AddFlowOutputsResponseTypeDef,
    UpdateFlowOutputResponseTypeDef,
    AddFlowSourcesResponseTypeDef,
    FlowTypeDef,
    UpdateFlowSourceResponseTypeDef,
    CreateFlowResponseTypeDef,
    DescribeFlowResponseTypeDef,
    UpdateFlowResponseTypeDef,
)


def get_structure() -> VpcInterfaceAttachmentTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-mediaconnect` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_mediaconnect/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
